<?php
if(!defined('ABSPATH')) exit;
class Anteraja extends WC_Shipping_Method{
	
 public $error_msg;

 public function __construct(){
  $this -> id = 'anteraja';
  $this -> title = 'Anteraja';
  $this -> method_title = 'Anteraja';
  $this -> method_description = __('Anteraja shipping method');
  $this -> enabled = 'yes';
  $this -> init_form_fields();
  $this -> init_settings();
 }
 public function init_form_fields(){
  $this -> form_fields  = array(
     'enabled' => array(
 	'title'   => __('Enable/Disable','woocommerce'),
	'type'    => 'checkbox',
	'label'   => __('Enable this shipping method','woocommerce'),
	'default' => 'yes',
     ),
    'pilihan_origin' => array(
       'type' => 'pilihan_origin'
     ),
    'pilihan_layanan' => array(
    	'type' => 'pilihan_layanan'
    ),
    'user_credential' => array(
  	'type' => 'user_credential'
    ),
    'shipper_info' => array(
    	'type' => 'shipper_info'
    )
  );
  add_action('woocommerce_update_options_shipping_'.$this->id,array(&$this, 'process_admin_options'));
  add_action('woocommerce_update_options_shipping_methods',array(&$this, 'process_admin_options'));					
  add_action('woocommerce_update_options_shipping_'.$this->id, array( &$this, 'process_update_data_tarif' ) );
 }
 public function generate_pilihan_origin_html() {  
   ob_start();
   echo '<tr align="left">';
   echo '<th scope="row" class="titledesc">Pilihan Kota<br>dan Kecamatan Asal</th>';
   echo '<td><p>Kota Asal: <select id="adm_anteraja_origin_city" name="origin_city">'.$this->get_kota_asal().'</select></p>';
   $kota_asal = get_option('epeken_anteraja_kota_asal');
   echo '<p>Kecamatan: <select id="adm_anteraja_origin_kec" name="origin_kecamatan"><option value="">-- Silakan Pilih --</option>'.$this->get_kecamatan_asal(esc_html($kota_asal)).'</select><p></td>';
   echo '</tr>';
   return ob_get_clean();
 }
 public function generate_pilihan_layanan_html() {
   ob_start();
   $layanan = get_option('epeken_anteraja_layanan');
   echo '<tr align="left">';
   echo '<th scope="row" class="titledesc">Pilihan Layanan</th>';
   $creg = '';
   if(in_array('Regular', $layanan))
	   $creg = 'checked';
   echo '<td>'; 
   echo'</p><input name="layanan_regular" type="checkbox" value="Regular" '.esc_html($creg).' />Regular</p>';
   $csd = '';
   if(in_array('Same Day', $layanan))
	   $csd = 'checked';
   echo '<p><input name="layanan_sameday" type="checkbox" value="Same Day" '.esc_html($csd).' />Same Day</p>';

   $cnd = '';
   if(in_array('Next Day', $layanan))
	   $cnd = 'checked';
   
   echo '<p><input name="layanan_nextday" type="checkbox" value="Next Day" '.esc_html($cnd).' />Next Day</p>'; 
   echo '</td></tr>';
   return ob_get_clean();
 }
 public function generate_user_credential_html() {
   ob_start();  
   $base_path = get_option('epeken_anteraja_basepath');
   $access_key_id = get_option('epeken_anteraja_access_key_id');
   $secret_access_key = get_option('epeken_anteraja_secret_access_key');
   $prefix = get_option('epeken_anteraja_prefix');
   echo '<tr align="left">';
   echo '<th scope="row" class="titledesc">Anteraja User <br>Credential</th>';
   echo '<td>';
   echo '<p>Basepath <br><input type="text" value = "'.esc_html($base_path).'" name="base_path"/></p>';
   echo '<p>Access Key Id <br><input type="text" value = "'.esc_html($access_key_id).'" name="access_key_id" /></p>';
   echo '<p>Secret Access Key <br><input type="text" value = "'.esc_html($secret_access_key).'" name="secret_access_key" /></p>';
   echo '<p>Prefix <br><input type="text" name="prefix" value = "'.esc_html($prefix).'" /></p>'; 
   echo '</td></tr>';
   return ob_get_clean();
 }
 function generate_shipper_info_html() {
   ob_start();
   $shipper_name = get_option('epeken_anteraja_shipper_name');
   $shipper_phone = get_option('epeken_anteraja_shipper_phone');
   $shipper_email = get_option('epeken_anteraja_shipper_email');
   $shipper_address = get_option('epeken_anteraja_shipper_address');
   $shipper_postcode = get_option('epeken_anteraja_shipper_postcode');
   echo '<tr align="left">';
   echo '<th scope="row" class="titledesc">Informasi Shipper</th><td>';
   echo '<p>Shipper Name <br><input type="text" value="'.esc_html($shipper_name).'" name="shipper_name" /></p>';
   echo '<p>Shipper Phone<br><input type="text" value="'.esc_html($shipper_phone).'" name="shipper_phone" /></p>';
   echo '<p>Shipper Email <br><input type="text" value="'.esc_html($shipper_email).'" name="shipper_email" /></p>';
   echo '<p>Shipper Address <br><input type="text" value="'.esc_html($shipper_address).'" name="shipper_address" /></p>';
   echo '<p>Shipper Postcode<br><input type="text" value="'.esc_html($shipper_postcode).'" name="shipper_postcode" /></p>';
   echo '</td></tr>';
   return ob_get_clean();
 }
 public function get_kecamatan_asal($kota) {
  if(empty($kota)){
    return '';
  }	
  $json = file_get_contents(EPEKEN_ANTERAJA_DIR_PATH.'assets/json/kecamatan.json');
  $json_decode = json_decode($json,true);
  $origin_kecamatan = get_option('epeken_anteraja_kecamatan_asal');
  $str = '';
  foreach($json_decode['data'] as $data){
    if($data['City'] !== $kota)
	    continue;
    $selected = '';
    if($origin_kecamatan === $data['Kecamatan']) 
	    $selected = 'selected';
    $str .= '<option value="'.esc_html($data['Kecamatan']).'" '.$selected.'>'.esc_html($data['Kecamatan']).'</option>'."\n"; 
  }
  return $str;
 }
 public function get_kota_asal() {
   $kota_asal = get_option('epeken_anteraja_kota_asal');
   $json = file_get_contents(EPEKEN_ANTERAJA_DIR_PATH.'assets/json/city.json');
   $json_decode = json_decode($json,true);
   $options = '';
   foreach($json_decode["City"] as $option) {
     $selected = '';
     if($option['City'] === $kota_asal)
	     $selected = 'selected';
     $options .= '<option value="'.esc_html($option['City']).'" '.$selected.'>'.esc_html($option['City']).'</option>'."\n";
   }
   return $options;
 }
 public function admin_options() {
   echo '<h2>Anteraja Settings</h2>';
   echo '<table>';
   $this -> generate_settings_html();
   echo '</table>';
 }
 public function is_anteraja_setting_page() {
	 return (is_admin() && sanitize_text_field($_GET['page']) === 'wc-settings' && 
		 sanitize_text_field($_GET['tab']) === 'shipping' && 
		 sanitize_text_field($_GET['section']) === 'anteraja');
 }
 public function validate_settings($params) {
    if(!is_email($params['shipper_email'])) {
	 $this -> error_msg = "Invalid Email";
	    return false;
    }
    if (!preg_match("/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i",$params['base_path'])) {
	    $this -> error_msg = "Invalid basepath URL";
	    return false;
    }
    return true;
 }

 public function error_when_save_settings() {
  if(empty($this -> error_msg))
	return;

  echo '<div class="notice notice-error is-dismissible">
         <p>Gagal menyimpan pengaturan. <strong>Pesan Error: '.esc_html($this -> error_msg).'</strong>. Mohon mencoba kembali.</p>
	 </div>'; 

  $this -> error_msg = '';
 }

 public function process_update_data_tarif() { 
  if(!$this -> validate_settings($_POST)) {
	add_action('updated_option', array(&$this,'error_when_save_settings'));	
	return;
  }
  update_option('epeken_anteraja_kota_asal', sanitize_text_field($_POST['origin_city']));
  update_option('epeken_anteraja_kecamatan_asal', sanitize_text_field($_POST['origin_kecamatan']));
  $layanan = array();
  if(sanitize_text_field($_POST['layanan_regular']) === 'Regular')
	  array_push($layanan,'Regular');
  if(sanitize_text_field($_POST['layanan_sameday']) === 'Same Day')
	  array_push($layanan,'Same Day');
  if(sanitize_text_field($_POST['layanan_nextday']) === 'Next Day')
	  array_push($layanan,'Next Day');
  update_option('epeken_anteraja_layanan', $layanan);
  update_option('epeken_anteraja_basepath', sanitize_text_field($_POST['base_path']));
  update_option('epeken_anteraja_access_key_id', sanitize_text_field($_POST['access_key_id']));
  update_option('epeken_anteraja_secret_access_key', sanitize_text_field($_POST['secret_access_key']));
  update_option('epeken_anteraja_prefix', sanitize_text_field($_POST['prefix']));
  update_option('epeken_anteraja_shipper_name', sanitize_text_field($_POST['shipper_name']));
  update_option('epeken_anteraja_shipper_phone', sanitize_text_field($_POST['shipper_phone']));
  update_option('epeken_anteraja_shipper_email', sanitize_text_field(sanitize_email($_POST['shipper_email'])));
  update_option('epeken_anteraja_shipper_address', sanitize_text_field($_POST['shipper_address']));
  update_option('epeken_anteraja_shipper_postcode', sanitize_text_field($_POST['shipper_postcode']));
  epkn_antr_save_credential(sanitize_text_field($_POST['base_path']), sanitize_text_field($_POST['access_key_id']),
			   sanitize_text_field($_POST['secret_access_key']), sanitize_text_field($_POST['prefix']));
 }

 public function get_package_weight($packages) {
	$tweight = 0;
 	foreach($packages['contents'] as $package) {
 		$product_id = $package['product_id'];
		if($package['variation_id'] > 0){
		 $product_id = $package['variation_id'];
		}
		$product = wc_get_product($product_id);
		$weight = $product -> get_weight();
		$tweight += $weight;
	}
	return $tweight;
 }

 public function calculate_shipping($package=array()){
   $logger = new WC_Logger();
   $logger -> add('anteraja','calculate shipping is invoked');
   $shipping = WC_Shipping::instance();
   $methods = $shipping -> get_shipping_methods();
   $epeken_all_kurir = $methods['epeken_courier'];
   $epeken_all_kurir -> get_destination_city_and_kecamatan();
   $shipping_city = urldecode($epeken_all_kurir -> shipping_city);
   $shipping_kecamatan = urldecode($epeken_all_kurir -> shipping_kecamatan);
   $origin_city = get_option('epeken_anteraja_kota_asal');
   $origin_kecamatan = get_option('epeken_anteraja_kecamatan_asal');
   $weight = $this -> get_package_weight($package);
   $weight_unit = get_option('woocommerce_weight_unit');
   
   if($weight_unit === 'kg')
	   $weight = $weight * 1000; //to gram

   $rates = epkn_antr_rate($origin_city,$origin_kecamatan,$shipping_city,$shipping_kecamatan,$weight);
   if(empty($rates))
      return;
   $rates = json_decode($rates,true);
   $layanan = get_option('epeken_anteraja_layanan');
   foreach($rates['result'] as $rate){
     if(!in_array($rate['product_name'], $layanan))
		   continue;
     $this -> add_rate(
	     array(
	     	 'id' => $this -> id.'_'.$rate['product_code'],
		 'label' => $this -> title.' '.$rate['product_name'].' ('.$rate['etd'].')',
		 'cost' => $rate['rates'],
		 'taxes' => false
       )
     );
   }
 }
}
?>
